/* Problem URL: https://codeforces.com/contest/903/problem/E */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, k;
    cin >> k >> n;

    V<string> fds(k);
    cin >> fds;

    vi diffs;

    int other = 0;

    vi c1(26);
    rep(i, n) {
        c1[fds[0][i] - 'a']++;
    }

    nrep(i, 1, k) {
        vi c2(26);
        rep(j, n) {
            if (fds[0][j] != fds[i][j]) {
                diffs.push_back(j);
            }
            c2[fds[i][j] - 'a']++;
        }

        if (c1 != c2) {
            cout << "-1\n";
            return 0;
        }

        if (!diffs.empty()) {
            other = i;
            break;
        }
    }

    if (diffs.empty()) {
        swap(fds[0][0], fds[0][1]);
        cout << fds[0] << '\n';
        return 0;
    }

    if (diffs.size() > 4) {
        cout << "-1\n";
        return 0;
    }

    string now = fds[0];
    auto test = [&]() {
        rep(i, diffs.size()) {
            rep(j, n) {
                if (diffs[i] == j) {
                    continue;
                }
                swap(now[diffs[i]], now[j]);

                auto diff = [&](string &a, string &b) {
                    vi count(26);
                    bool lmao = false;

                    int ans = 0;
                    rep(i, n) {
                        count[a[i] - 'a']++;
                        lmao = lmao || count[a[i] - 'a'] >= 2;
                        if (a[i] != b[i]) {
                            ans++;
                        }
                    }

                    return ans == 2 || (ans == 0 && lmao);
                };

                bool pos = true;

                rep(l, k) {
                    int d = diff(now, fds[l]);
                    if (!diff(now, fds[l])) {
                        pos = false;
                        break;
                    }
                }

                if (pos) {
                    return true;
                }

                swap(now[diffs[i]], now[j]);
            }
        }

        return false;
    };

    if (test()) {
        cout << now << '\n';
        return 0;
    }

    now = fds[other];

    if (test()) {
        cout << now << '\n';
        return 0;
    }

    cout << "-1\n";
}
